// Blynk constants
#define BLYNK_TEMPLATE_ID "TMPL6OgNufWln"
#define BLYNK_TEMPLATE_NAME "Bedroom Sound Device"
#define BLYNK_AUTH_TOKEN "-oPOvt4_8nF4uyEYdcpfwEgGyveC5Fc7"
#define BLYNK_PRINT SerialUSB

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>
#include "PixelManager.h"


// Wifi setup stuff
char ssid[] = "HPNA3-163";
char pass[] = "0051755081";
#define EspSerial Serial1
#define ESP8266_BAUD 115200
ESP8266 wifi(&EspSerial);

// Notes for the nightmarish song tune
#define NOTE_E5  (659)
#define NOTE_D5  (587)
#define NOTE_FS4 (370)
#define NOTE_GS4 (415)
#define NOTE_CS5 (554)
#define NOTE_B4  (494)
#define NOTE_D4  (294)
#define NOTE_E4  (330)
#define NOTE_A4  (440)
#define NOTE_CS4 (277)

// All the notes in the tune, their tempo and beat, and the notes amount
float tune_notes[] = {NOTE_E5, NOTE_D5, NOTE_FS4, NOTE_GS4, NOTE_CS5, NOTE_B4, NOTE_D4, NOTE_E4, NOTE_B4, NOTE_A4, NOTE_CS4, NOTE_E4, NOTE_A4};
int tune_beats[] = {4, 4, 2, 2, 4, 4, 2, 2, 4, 4, 2, 2, 2};
int tempo = 40;
const int notes_length = sizeof(tune_notes) / sizeof(tune_notes[0]);

// This tells us whether the sound should be playing or not
int isSoundOn = 0;


void setup()
{
    // Debug console
    SerialUSB.begin(115200);
    CircuitPlayground.begin();

    // Set ESP8266 baud rate
    EspSerial.begin(ESP8266_BAUD);
    delay(10);

    Blynk.begin(BLYNK_AUTH_TOKEN, wifi, ssid, pass);
}


void loop() {
    Blynk.run();

    if (isSoundOn) {
        // Light up the pixels and play the tune
        for (int i = 0; i < notes_length; i++) {
            CircuitPlayground.playTone(tune_notes[i], tune_beats[i] * tempo);
            PixelManager::set_pixels_rainbow(i % RAINBOW_SIZE);
        }
    } else {
        CircuitPlayground.clearPixels();
    }
}

BLYNK_WRITE(V0) {
    // Should we play the sound or not
    int value = param.asInt();
    isSoundOn = value;
}
